SketchUp C API

- Main Page
- Related Pages
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Related Functions
SUDimensionRadialRef Struct Reference

A radial dimension entity reference. More...

`#include <SketchUpAPI/model/dimension_radial.h>`

Inherits SUDimensionRef.

## Related Functions
(Note that these are not member functions.)
SUDimensionRef | SUDimensionRadialToDimension (SUDimensionRadialRef dimension)
| Converts from an SUDimensionRadialRef to an SUDimensionRef. This is essentially an upcast operation. More...
SUDimensionRadialRef | SUDimensionRadialFromDimension (SUDimensionRef dimension)
| Converts from an SUDimensionRef to an SUDimensionRadialRef. This is essentially a downcast operation so the given SUDimensionRef must be convertible to an SUDimensionRadialRef. More...
enum SUResult | SUDimensionRadialCreate (SUDimensionRadialRef *dimension, SUInstancePathRef path)
| Creates a new radial dimension for measuring the provided arccurve. More...
enum SUResult | SUDimensionRadialRelease (SUDimensionRadialRef *dimension)
| Releases a dimension object. More...
enum SUResult | SUDimensionRadialGetCurveInstancePath (SUDimensionRadialRef dimension, SUInstancePathRef *path)
| Retrieves the arccurve instance being mesured by a dimension object. The given instance path object either must have been constructed using one of the SUInstancePathCreate* functions or it will be generated on the fly if it is invalid. It must be released using SUInstancePathRelease() when it is no longer needed. More...
enum SUResult | SUDimensionRadialSetCurveInstancePath (SUDimensionRadialRef dimension, SUInstancePathRef path)
| Sets which arccurve instance is measured by the radial dimension. The instance path's leaf entity must be an arccurve for this method to succeed. More...
enum SUResult | SUDimensionRadialGetDiameter (SUDimensionRadialRef dimension, bool *is_diameter)
| Retrieves whether the dimension is a diameter. Radial dimensions can be used to measure either diameter or radius. More...
enum SUResult | SUDimensionRadialSetDiameter (SUDimensionRadialRef dimension, bool is_diameter)
| Sets whether the dimension measures diameter or radius. More...
enum SUResult | SUDimensionRadialGetLeaderBreakPoint (SUDimensionRadialRef dimension, struct SUPoint3D *point)
| Gets the radial dimension's leader line break point. The leader line break point is the point where the leader line bends towards the dimension label. More...
enum SUResult | SUDimensionRadialSetLeaderBreakPoint (SUDimensionRadialRef dimension, const struct SUPoint3D *point)
| Sets the radial dimension's leader break point. More...
enum SUResult | SUDimensionRadialGetLeaderPoints (SUDimensionRadialRef dimension, struct SUPoint3D points[3])
| Retrieves the a dimension object's leader points. The three returned pointe are [0] the point at which the dimension's text touches the leader line, [1] the point at which the dimension's arrow attaches to the dimensioned curve, [2] the point on the dimensioned curve's full circle opposite of point [1]. More...
Related Functions inherited from SUDimensionRef
SUEntityRef | SUDimensionToEntity (SUDimensionRef dimension)
| Converts from an SUDimensionRef to an SUEntityRef. This is essentially an upcast operation. More...
SUDimensionRef | SUDimensionFromEntity (SUEntityRef entity)
| Converts from an SUEntityRef to an SUDimensionRef. This is essentially a downcast operation so the given SUEntityRef must be convertible to an SUDimensionRef. More...
SUDrawingElementRef | SUDimensionToDrawingElement (SUDimensionRef dimension)
| Converts from an SUDimensionRef to an SUDrawingElementRef. This is essentially an upcast operation. More...
SUDimensionRef | SUDimensionFromDrawingElement (SUDrawingElementRef element)
| Converts from an SUDrawingElementRef to an SUDimensionRef. This is essentially a downcast operation so the given SUDrawingElementRef must be convertible to an SUDimensionRef. More...
enum SUResult | SUDimensionGetType (SUDimensionRef dimension, enum SUDimensionType *type)
| Retrieves an enum value indicating the dimension type (linear or radial). More...
enum SUResult | SUDimensionGetText (SUDimensionRef dimension, SUStringRef *text)
| Retrieves the text of a dimension object. More...
enum SUResult | SUDimensionSetText (SUDimensionRef dimension, const char *text)
| Sets the text of a dimension object. More...
enum SUResult | SUDimensionGetPlane (SUDimensionRef dimension, struct SUPlane3D *plane)
| Retrieves the plane of a dimension object. More...
enum SUResult | SUDimensionGetText3D (SUDimensionRef dimension, bool *is_text_3d)
| Retrieves a boolean indicating if the dimension text is 3D. More...
enum SUResult | SUDimensionSetText3D (SUDimensionRef dimension, bool is_text_3d)
| Sets a boolean indicating whether the dimension text is 3D. More...
enum SUResult | SUDimensionGetArrowType (SUDimensionRef dimension, enum SUArrowType *type)
| Retrieves an enum value indicating the dimension's arrow type. More...
enum SUResult | SUDimensionSetArrowType (SUDimensionRef dimension, enum SUArrowType type)
| Sets the dimension's arrow type. More...
enum SUResult | SUDimensionGetFont (SUDimensionRef dimension, SUFontRef *font)
| Get the dimension's font reference. More...
enum SUResult | SUDimensionSetFont (SUDimensionRef dimension, SUFontRef font)
| Sets the dimension's font from a font reference. More...
Related Functions inherited from SUDrawingElementRef
SUEntityRef | SUDrawingElementToEntity (SUDrawingElementRef elem)
| Converts from an SUDrawingElementRef to an SUEntityRef. This is essentially an upcast operation. More...
SUDrawingElementRef | SUDrawingElementFromEntity (SUEntityRef entity)
| Converts from an SUEntityRef to an SUDrawingElementRef. This is essentially a downcast operation so the given entity must be convertible to a drawing element. More...
enum SURefType | SUDrawingElementGetType (SUDrawingElementRef elem)
| Returns the concrete type of the given drawing element. More...
enum SUResult | SUDrawingElementGetBoundingBox (SUDrawingElementRef elem, struct SUBoundingBox3D *bbox)
| Retrieves the bounding box of a drawing element. More...
enum SUResult | SUDrawingElementGetMaterial (SUDrawingElementRef elem, SUMaterialRef *material)
| Retrieves the material object of a drawing element. More...
enum SUResult | SUDrawingElementSetMaterial (SUDrawingElementRef elem, SUMaterialRef material)
| Sets the material of a drawing element. More...
enum SUResult | SUDrawingElementGetLayer (SUDrawingElementRef elem, SULayerRef *layer)
| Retrieves the layer object associated with a drawing element. More...
enum SUResult | SUDrawingElementSetLayer (SUDrawingElementRef elem, SULayerRef layer)
| Sets the layer object to be associated with a drawing element. More...
enum SUResult | SUDrawingElementSetHidden (SUDrawingElementRef elem, bool hide_flag)
| Sets the hide flag of a drawing element. More...
enum SUResult | SUDrawingElementGetHidden (SUDrawingElementRef elem, bool *hide_flag)
| Retrieves the hide flag of a drawing element. More...
enum SUResult | SUDrawingElementSetCastsShadows (SUDrawingElementRef elem, bool casts_shadows_flag)
| Sets the casts shadows flag of a drawing element. More...
enum SUResult | SUDrawingElementGetCastsShadows (SUDrawingElementRef elem, bool *casts_shadows_flag)
| Retrieves the casts shadows flag of a drawing element. More...
enum SUResult | SUDrawingElementSetReceivesShadows (SUDrawingElementRef elem, bool receives_shadows_flag)
| Sets the receives shadows flag of a drawing element. More...
enum SUResult | SUDrawingElementGetReceivesShadows (SUDrawingElementRef elem, bool *receives_shadows_flag)
| Retrieves the receives shadows flag of a drawing element. More...
Related Functions inherited from SUEntityRef
enum SURefType | SUEntityGetType (SUEntityRef entity)
| Returns the concrete type of the given entity. More...
enum SUResult | SUEntityGetID (SUEntityRef entity, int32_t *entity_id)
| Retrieves the id of the entity. More...
enum SUResult | SUEntityGetPersistentID (SUEntityRef entity, int64_t *entity_pid)
| Retrieves the persistent id of the entity. More...
enum SUResult | SUEntityGetNumAttributeDictionaries (SUEntityRef entity, size_t *count)
| Retrieves the number of attribute dictionaries of an entity. More...
enum SUResult | SUEntityGetAttributeDictionaries (SUEntityRef entity, size_t len, SUAttributeDictionaryRef dictionaries[], size_t *count)
| Retrieves the attribute dictionaries of an entity. More...
enum SUResult | SUEntityAddAttributeDictionary (SUEntityRef entity, SUAttributeDictionaryRef dictionary)
| Adds the attribute dictionary to an entity. The given dictionary object must not belong to another entity. In other words, each dictionary should be added to one entity only. More...
enum SUResult | SUEntityGetAttributeDictionary (SUEntityRef entity, const char *name, SUAttributeDictionaryRef *dictionary)
| Retrieves the attribute dictionary of an entity that has the given name. More...
enum SUResult | SUEntityGetModel (SUEntityRef entity, SUModelRef *model)
| Retrieves the model object associated with the entity. More...
enum SUResult | SUEntityGetParentEntities (SUEntityRef entity, SUEntitiesRef *entities)
| Retrieves the entities object which contains the entity. More...

## Detailed Description

A radial dimension entity reference.

Since
  SketchUp 2017, API 5.0

## Friends And Related Function Documentation

enum SUResult SUDimensionRadialCreate | ( | SUDimensionRadialRef * | dimension,
|  | SUInstancePathRef | path
| ) |  |
| related

Creates a new radial dimension for measuring the provided arccurve.

Since
  SketchUp 2017, API 5.0

Parameters

  [in,out] | dimension | The dimension object created.
  [in] | path | The and instance path to the arccurve to be measured.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_NULL_POINTER_OUTPUT if dimension is NULL
  - SU_ERROR_OVERWRITE_VALID if dimension already references a valid object
  - SU_ERROR_INVALID_INPUT if path is not a valid object
  - SU_ERROR_INVALID_ARGUMENT if path is valid but refers to an invalid instance path
  - SU_ERROR_GENERIC if path refers to a valid instance path but the path's leaf is not an arccurve

SUDimensionRadialRef SUDimensionRadialFromDimension | ( | SUDimensionRef | dimension | ) |
| related

Converts from an SUDimensionRef to an SUDimensionRadialRef. This is essentially a downcast operation so the given SUDimensionRef must be convertible to an SUDimensionRadialRef.

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | dimension | The given dimension reference.

Returns
  - The converted SUDimensionRadialRef if the downcast operation succeeds
  - If not, the returned reference will be invalid

enum SUResult SUDimensionRadialGetCurveInstancePath | ( | SUDimensionRadialRef | dimension,
|  | SUInstancePathRef * | path
| ) |  |
| related

Retrieves the arccurve instance being mesured by a dimension object. The given instance path object either must have been constructed using one of the SUInstancePathCreate* functions or it will be generated on the fly if it is invalid. It must be released using SUInstancePathRelease() when it is no longer needed.

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | dimension | The dimension object.
  [out] | path | The instance path retrieved.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if dimension is not a valid object
  - SU_ERROR_NULL_POINTER_OUTPUT if path is NULL

enum SUResult SUDimensionRadialGetDiameter | ( | SUDimensionRadialRef | dimension,
|  | bool * | is_diameter
| ) |  |
| related

Retrieves whether the dimension is a diameter. Radial dimensions can be used to measure either diameter or radius.

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | dimension | The dimension object.
  [out] | is_diameter | The flag value retrieved.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if dimension is not a valid object
  - SU_ERROR_NULL_POINTER_OUTPUT if is_diameter is NULL

enum SUResult SUDimensionRadialGetLeaderBreakPoint | ( | SUDimensionRadialRef | dimension,
|  | struct SUPoint3D * | point
| ) |  |
| related

Gets the radial dimension's leader line break point. The leader line break point is the point where the leader line bends towards the dimension label.

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | dimension | The dimension object.
  [out] | point | The point retrieved.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if dimension is not a valid object
  - SU_ERROR_NULL_POINTER_OUTPUT if point is NULL

enum SUResult SUDimensionRadialGetLeaderPoints | ( | SUDimensionRadialRef | dimension,
|  | struct SUPoint3D | points[3]
| ) |  |
| related

Retrieves the a dimension object's leader points. The three returned pointe are [0] the point at which the dimension's text touches the leader line, [1] the point at which the dimension's arrow attaches to the dimensioned curve, [2] the point on the dimensioned curve's full circle opposite of point [1].

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | dimension | The dimension object.
  [out] | points | The array of 3 3d points retrieved.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if dimension is not a valid object
  - SU_ERROR_NULL_POINTER_OUTPUT if points is NULL

enum SUResult SUDimensionRadialRelease | ( | SUDimensionRadialRef * | dimension | ) |
| related

Releases a dimension object.

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | dimension | The dimension object.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if dimension is an invalid object
  - SU_ERROR_NULL_POINTER_INPUT if dimension is NULL

enum SUResult SUDimensionRadialSetCurveInstancePath | ( | SUDimensionRadialRef | dimension,
|  | SUInstancePathRef | path
| ) |  |
| related

Sets which arccurve instance is measured by the radial dimension. The instance path's leaf entity must be an arccurve for this method to succeed.

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | dimension | The dimension object modified.
  [in] | path | The and instance path to the arccurve to be measured.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if dimension or path are not valid objects
  - SU_ERROR_INVALID_ARGUMENT if path is valid but refers to an invalid instance path
  - SU_ERROR_GENERIC if path refers to a valid instance path but the path's leaf is not an arccurve

enum SUResult SUDimensionRadialSetDiameter | ( | SUDimensionRadialRef | dimension,
|  | bool | is_diameter
| ) |  |
| related

Sets whether the dimension measures diameter or radius.

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | dimension | The dimension object.
  [in] | is_diameter | The flag specifying if the dimension measures diameter.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if dimension is not a valid object

enum SUResult SUDimensionRadialSetLeaderBreakPoint | ( | SUDimensionRadialRef | dimension,
|  | const struct SUPoint3D * | point
| ) |  |
| related

Sets the radial dimension's leader break point.

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | dimension | The dimension object.
  [in] | point | The point retrieved.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if dimension is not a valid object
  - SU_ERROR_NULL_POINTER_INPUT if point is NULL

SUDimensionRef SUDimensionRadialToDimension | ( | SUDimensionRadialRef | dimension | ) |
| related

Converts from an SUDimensionRadialRef to an SUDimensionRef. This is essentially an upcast operation.

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | dimension | The given dimension reference.

Returns
  - The converted SUDimensionRef if dimension is a valid object
  - If not, the returned reference will be invalid

The documentation for this struct was generated from the following files:

- SketchUpAPI/model/defs.h
- SketchUpAPI/model/dimension_radial.h